--- linuxppc_2_4_devel-D2004-05-07/adeos/ppc.c.ADEOS	Tue Jun 15 12:06:37 2004
+++ linuxppc_2_4_devel-D2004-05-07/adeos/ppc.c	Tue Jun 15 11:30:04 2004
@@ -0,0 +1,493 @@
+/*
+ *   linux/adeos/ppc.c
+ *
+ *   Copyright (C) 2004 Wolfgang Grandegger.
+ *   Copyright (C) 2003 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ *   Architecture-dependent ADEOS support for PowerPC.
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <asm/system.h>
+#include <asm/hw_irq.h>
+#include <asm/irq.h>
+#include <asm/atomic.h>
+#include <asm/time.h>
+#include <asm/io.h>
+
+extern spinlock_t __adeos_pipelock;
+
+extern unsigned long __adeos_virtual_irq_map;
+
+extern struct list_head __adeos_pipeline;
+
+extern irq_desc_t irq_desc[];
+
+extern struct pt_regs __adeos_irq_regs;
+
+asmlinkage void do_IRQ(int irq, struct pt_regs *regs);
+
+static struct hw_interrupt_type __adeos_std_irq_dtype[NR_IRQS];
+
+static void __adeos_override_irq_enable (unsigned irq)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+
+    adeos_hw_local_irq_save(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+    __adeos_unlock_irq(adp_cpu_current[cpuid],irq);
+    __adeos_std_irq_dtype[irq].enable(irq);
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_hw_local_irq_restore(hwflags);
+}
+
+static void __adeos_override_irq_disable (unsigned irq)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+
+    adeos_hw_local_irq_save(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+    __adeos_std_irq_dtype[irq].disable(irq);
+    __adeos_lock_irq(adp_cpu_current[cpuid],cpuid,irq);
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_hw_local_irq_restore(hwflags);
+}
+
+static void __adeos_override_irq_end (unsigned irq)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+
+    adeos_hw_local_irq_save(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+
+    if (!(irq_desc[irq].status & (IRQ_DISABLED|IRQ_INPROGRESS)))
+	__adeos_unlock_irq(adp_cpu_current[cpuid],irq);
+
+    __adeos_std_irq_dtype[irq].end(irq);
+
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_hw_local_irq_restore(hwflags);
+}
+
+static void __adeos_override_irq_affinity (unsigned irq, unsigned long mask)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+
+    adeos_hw_local_irq_save(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+    __adeos_std_irq_dtype[irq].set_affinity(irq,mask);
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_hw_local_irq_restore(hwflags);
+}
+
+static int __adeos_ack_irq (unsigned irq)
+
+{
+    irq_desc_t *desc = irq_desc + irq;
+
+    if (desc->handler->ack != NULL)
+	{
+#ifdef CONFIG_PREEMPT
+	preempt_disable();
+#endif /* CONFIG_PREEMPT */
+	desc->handler->ack(irq);
+#ifdef CONFIG_PREEMPT
+	preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+	}
+    return 1;
+}
+
+/* __adeos_enable_pipeline() -- Take over the interrupt control from
+   the root domain (i.e. Linux). After this routine has returned, all
+   interrupts go through the pipeline. */
+
+void __adeos_enable_pipeline (void)
+
+{
+    unsigned long flags;
+    unsigned irq;
+
+    flags = adeos_critical_enter(NULL);
+
+    /* First, virtualize all interrupts from the root domain. */
+
+    for (irq = 0; irq < NR_IRQS; irq++)
+	adeos_virtualize_irq(irq,
+			     (void (*)(unsigned))&adeos_do_IRQ,
+			     &__adeos_ack_irq,
+			     IPIPE_HANDLE_MASK|IPIPE_PASS_MASK);
+
+    /* We use a virtuale IRQ to handle the timer irq (decrementer trap) */
+
+    __adeos_timer_virq = adeos_alloc_irq();
+    adeos_virtualize_irq(__adeos_timer_virq,
+			 (void (*)(unsigned))&adeos_timer_interrupt,
+			 NULL,
+			 IPIPE_HANDLE_MASK|IPIPE_PASS_MASK);
+  
+
+    /* Interpose on the IRQ control routines so we can make them
+       atomic using hw masking and prevent the interrupt log from
+       being untimely flushed. */
+
+    for (irq = 0; irq < NR_IRQS; irq++) 
+	{
+	if (irq_desc[irq].handler != NULL)
+	    __adeos_std_irq_dtype[irq] = *irq_desc[irq].handler;
+	}
+
+    /* The original controller structs are often shared, so we first
+       save them all before changing any of them. Notice that we don't
+       redirect the ack handler since the relevant IC management code
+       is already Adeos-aware. */
+
+    for (irq = 0; irq < NR_IRQS; irq++)
+	{
+	struct hw_interrupt_type *handler = irq_desc[irq].handler;
+	if (handler == NULL) continue;
+	if (handler->enable != NULL)
+	    handler->enable = &__adeos_override_irq_enable;
+	if (handler->disable != NULL)
+	    handler->disable = &__adeos_override_irq_disable;
+	if (handler->end != NULL)
+	    handler->end = &__adeos_override_irq_end;
+	if (handler->set_affinity != NULL)
+	    handler->set_affinity = &__adeos_override_irq_affinity;
+	}
+
+#ifdef CONFIG_ADEOS_MODULE
+    adp_pipelined = 1;
+#endif /* CONFIG_ADEOS_MODULE */
+
+    adeos_critical_exit(flags);
+}
+
+/* __adeos_disable_pipeline() -- Disengage the pipeline. */
+
+void __adeos_disable_pipeline (void)
+
+{
+    unsigned long flags;
+    unsigned irq;
+
+    flags = adeos_critical_enter(NULL);
+
+    /* Restore interrupt controllers. */
+
+    for (irq = 0; irq < NR_IRQS; irq++)
+	{
+	if (irq_desc[irq].handler != NULL)
+	    *irq_desc[irq].handler = __adeos_std_irq_dtype[irq];
+	}
+
+#ifdef CONFIG_ADEOS_MODULE
+    adp_pipelined = 0;
+#endif /* CONFIG_ADEOS_MODULE */
+
+    adeos_critical_exit(flags);
+}
+
+/* adeos_virtualize_irq_from() -- Attach a handler (and optionally a
+   hw acknowledge routine) to an interrupt for the given domain. */
+
+int adeos_virtualize_irq_from (adomain_t *adp,
+			       unsigned irq,
+			       void (*handler)(unsigned irq),
+			       int (*acknowledge)(unsigned irq),
+			       unsigned modemask)
+{
+    unsigned long flags;
+    int err;
+
+    if (irq >= IPIPE_NR_IRQS)
+	return -EINVAL;
+
+    if (adp->irqs[irq].control & IPIPE_SYSTEM_MASK)
+	return -EPERM;
+	
+    adeos_spin_lock_irqsave(&__adeos_pipelock,flags);
+
+    if (handler != NULL)
+	{
+	/* A bit of hack here: if we are re-virtualizing an IRQ just
+	   to change the acknowledge routine by passing the special
+	   ADEOS_SAME_HANDLER value, then allow to recycle the current
+	   handler for the IRQ. This allows Linux device drivers
+	   managing shared IRQ lines to call adeos_virtualize_irq() in
+	   addition to request_irq() just for the purpose of
+	   interposing their own shared acknowledge routine. */
+
+	if (handler == ADEOS_SAME_HANDLER)
+	    {
+	    handler = adp->irqs[irq].handler;
+
+	    if (handler == NULL)
+		{
+		err = -EINVAL;
+		goto unlock_and_exit;
+		}
+	    }
+	else if ((modemask & IPIPE_EXCLUSIVE_MASK) != 0 &&
+		 adp->irqs[irq].handler != NULL)
+	    {
+	    err = -EBUSY;
+	    goto unlock_and_exit;
+	    }
+	
+	if ((modemask & (IPIPE_SHARED_MASK|IPIPE_PASS_MASK)) == IPIPE_SHARED_MASK)
+	    {
+	    err = -EINVAL;
+	    goto unlock_and_exit;
+	    }
+
+	if ((modemask & IPIPE_STICKY_MASK) != 0)
+	    modemask |= IPIPE_HANDLE_MASK;
+	}
+    else
+	modemask &= ~(IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK|IPIPE_SHARED_MASK);
+
+    if (acknowledge == NULL)
+	{
+	if ((modemask & IPIPE_SHARED_MASK) == 0)
+	    /* Acknowledge handler unspecified -- this is ok in
+	       non-shared management mode, but we will force the use
+	       of the Linux-defined handler instead. */
+	    acknowledge = adp_root->irqs[irq].acknowledge;
+	else
+	    {
+	    /* A valid acknowledge handler to be called in shared mode
+	       is required when declaring a shared IRQ. */
+	    err = -EINVAL;
+	    goto unlock_and_exit;
+	    }
+	}
+
+    adp->irqs[irq].handler = handler;
+    adp->irqs[irq].acknowledge = acknowledge;
+    adp->irqs[irq].control = modemask;
+
+    if (irq < NR_IRQS &&
+	handler != NULL &&
+	!adeos_virtual_irq_p(irq) &&
+	(modemask & IPIPE_ENABLE_MASK) != 0)
+	{
+	if (adp != adp_current)
+	    {
+	    /* IRQ enable/disable state is domain-sensitive, so we may
+	       not change it for another domain. What is allowed
+	       however is forcing some domain to handle an interrupt
+	       source, by passing the proper 'adp' descriptor which
+	       thus may be different from adp_current. */
+	    err = -EPERM;
+	    goto unlock_and_exit;
+	    }
+
+	enable_irq(irq);
+	}
+
+    err = 0;
+
+unlock_and_exit:
+
+    adeos_spin_unlock_irqrestore(&__adeos_pipelock,flags);
+
+    return err;
+}
+
+/* adeos_control_irq() -- Change an interrupt mode. This affects the
+   way a given interrupt is handled by ADEOS for the current
+   domain. setmask is a bitmask telling whether:
+   - the interrupt should be passed to the domain (IPIPE_HANDLE_MASK),
+     and/or
+   - the interrupt should be passed down to the lower priority domain(s)
+     in the pipeline (IPIPE_PASS_MASK).
+   This leads to four possibilities:
+   - PASS only => Ignore the interrupt
+   - HANDLE only => Terminate the interrupt (process but don't pass down)
+   - PASS + HANDLE => Accept the interrupt (process and pass down)
+   - <none> => Discard the interrupt
+   - DYNAMIC is currently an alias of HANDLE since it marks an interrupt
+   which is processed by the current domain but not implicitely passed
+   down to the pipeline, letting the domain's handler choose on a case-
+   by-case basis whether the interrupt propagation should be forced
+   using adeos_propagate_irq().
+   clrmask clears the corresponding bits from the control field before
+   setmask is applied.
+*/
+
+int adeos_control_irq (unsigned irq,
+		       unsigned clrmask,
+		       unsigned setmask)
+{
+    irq_desc_t *desc;
+    unsigned long flags;
+
+    if (irq >= IPIPE_NR_IRQS)
+	return -EINVAL;
+
+    if (adp_current->irqs[irq].control & IPIPE_SYSTEM_MASK)
+	return -EPERM;
+	
+    if (((setmask|clrmask) & IPIPE_SHARED_MASK) != 0)
+	return -EINVAL;
+	
+    desc = irq_desc + irq;
+
+    if (adp_current->irqs[irq].handler == NULL)
+	setmask &= ~(IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK);
+
+    if ((setmask & IPIPE_STICKY_MASK) != 0)
+	setmask |= IPIPE_HANDLE_MASK;
+
+    if ((clrmask & (IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK)) != 0)	/* If one goes, both go. */
+	clrmask |= (IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK);
+
+    adeos_spin_lock_irqsave(&__adeos_pipelock,flags);
+
+    adp_current->irqs[irq].control &= ~clrmask;
+    adp_current->irqs[irq].control |= setmask;
+
+    if ((setmask & IPIPE_ENABLE_MASK) != 0)
+	enable_irq(irq);
+    else if ((clrmask & IPIPE_ENABLE_MASK) != 0)
+	disable_irq(irq);
+
+    adeos_spin_unlock_irqrestore(&__adeos_pipelock,flags);
+
+    return 0;
+}
+
+void __adeos_init_domain (adomain_t *adp, adattr_t *attr)
+
+{
+    int estacksz = attr->estacksz > 0 ? attr->estacksz : 8192, _cpuid;
+    adeos_declare_cpuid;
+    unsigned long flags;
+
+    adeos_hw_local_irq_flags(flags);
+
+    for (_cpuid = 0; _cpuid < smp_num_cpus; _cpuid++)
+	{
+	int **psp = &adp->esp[_cpuid];
+
+	adp->estackbase[_cpuid] = (int *)kmalloc(estacksz,GFP_KERNEL);
+    
+	if (adp->estackbase[_cpuid] == NULL)
+	    panic("Adeos: No memory for domain stack on CPU #%d",_cpuid);
+
+	adp->esp[_cpuid] = adp->estackbase[_cpuid];
+	**psp = 0;
+	*psp = (int *)(((unsigned long)*psp + estacksz - 0x10) & ~0xf);
+	memset(*psp - 36, 0, 36);
+	*(*psp - 29) = (_cpuid == cpuid);	/* r3 */
+	*(*psp - 35) = (int)attr->entry;	/* lr */
+	*(*psp - 36) = flags & ~MSR_EE;		/* msr */
+	}
+}
+
+void __adeos_cleanup_domain (adomain_t *adp)
+
+{
+    adeos_unstall_pipeline_from(adp);
+
+    if (adp->estackbase[0] != NULL)
+	kfree(adp->estackbase[0]);
+}
+
+int adeos_get_sysinfo (adsysinfo_t *info)
+
+{
+    info->ncpus = 1;
+    info->cpufreq = HZ * tb_ticks_per_jiffy;;
+    info->archdep.tmirq = __adeos_timer_virq;
+
+    return 0;
+}
+
+int adeos_tune_timer (unsigned long ns, int flags)
+
+{
+    unsigned long x, hz;
+
+    if (flags & ADEOS_RESET_TIMER)
+	hz = HZ;
+    else
+	{
+	if (ns < 50000)	/* FIXME: this needs to be defined more accurately */
+	    return -EINVAL;
+
+	hz = 1000000000 / ns;
+	}
+
+    adeos_hw_local_irq_save(x);
+
+    printk("adeos_tune_timer: to be implemented\n");
+    //__adeos_tune_timer(hz);
+
+    adeos_hw_local_irq_restore(x);
+
+    return 0;
+}
+
+/* adeos_trigger_ipi() -- Send the ADEOS service IPI to other
+   processors. Not implemented for this architecture. */
+
+int adeos_trigger_ipi (int _cpuid)
+
+{
+    printk(KERN_WARNING "Adeos: Call to unimplemented adeos_trigger_ipi() from %s\n",adp_current->name);
+    return 0;
+}
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/config.in.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/config.in
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/config.in.ADEOS	Thu May  6 23:20:13 2004
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/config.in	Mon Jun  7 22:49:48 2004
@@ -643,7 +643,12 @@
 fi
 
 bool 'Networking support' CONFIG_NET
-bool 'Sysctl support' CONFIG_SYSCTL
+tristate 'Adeos support' CONFIG_ADEOS
+if [ "$CONFIG_ADEOS" != "n" ]; then
+   define_bool CONFIG_ADEOS_CORE y
+fi
+#bool 'Sysctl support' CONFIG_SYSCTL
+define_bool CONFIG_SYSCTL y
 bool 'System V IPC' CONFIG_SYSVIPC
 bool 'BSD Process Accounting' CONFIG_BSD_PROCESS_ACCT
 
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/adeos.c.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/adeos.c
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/adeos.c.ADEOS	Tue Jun 15 12:06:37 2004
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/adeos.c	Mon Jun  7 22:50:41 2004
@@ -0,0 +1,414 @@
+/*
+ *   linux/arch/ppc/kernel/adeos.c
+ *
+ *   Copyright (C) 2004 Wolfgang Grandegger.
+ *   Copyright (C) 2003 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ *   Architecture-dependent ADEOS core support for PowerPC
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/smp.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/bitops.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <asm/system.h>
+#include <asm/atomic.h>
+#include <asm/hw_irq.h>
+#include <asm/irq.h>
+#include <asm/io.h>
+
+int do_IRQ(struct pt_regs *regs);
+
+extern struct list_head __adeos_pipeline;
+
+#ifdef CONFIG_ADEOS_MODULE
+/* A global flag telling whether Adeos pipelining is engaged. */
+int adp_pipelined = 0;
+#endif /* CONFIG_ADEOS_MODULE */
+
+struct pt_regs __adeos_irq_regs;
+
+int __adeos_timer_virq;
+
+#define ffnz(x) (ffs(x) - 1)
+
+/* adeos_critical_enter() -- Grab the superlock for entering a global
+   critical section. On this uniprocessor-only arch, this is identical
+   to hw cli(). */
+
+unsigned long adeos_critical_enter (void (*syncfn)(void))
+
+{
+    unsigned long flags;
+    adeos_hw_local_irq_save(flags);
+    return flags;
+}
+
+/* adeos_critical_exit() -- Release the superlock. */
+
+void adeos_critical_exit (unsigned long flags) {
+
+    adeos_hw_local_irq_restore(flags);
+}
+
+void __adeos_init_stage (adomain_t *adp)
+
+{
+    int cpuid, n;
+
+    for (cpuid = 0; cpuid < ADEOS_NR_CPUS; cpuid++)
+	{
+	adp->cpudata[cpuid].irq_pending_hi = 0;
+
+	for (n = 0; n < IPIPE_IRQ_IWORDS; n++)
+	    adp->cpudata[cpuid].irq_pending_lo[n] = 0;
+
+	for (n = 0; n < IPIPE_NR_IRQS; n++)
+	    adp->cpudata[cpuid].irq_hits[n] = 0;
+	}
+
+    for (n = 0; n < IPIPE_NR_IRQS; n++)
+	{
+	adp->irqs[n].acknowledge = NULL;
+	adp->irqs[n].handler = NULL;
+	adp->irqs[n].control = IPIPE_PASS_MASK;	/* Pass but don't handle */
+	}
+}
+
+/* __adeos_sync_stage() -- Flush the pending IRQs for the current
+   domain (and processor).  This routine flushes the interrupt log
+   (see "Optimistic interrupt protection" from D. Stodolsky et al. for
+   more on the deferred interrupt scheme). Every interrupt that
+   occurred while the pipeline was stalled gets played.  WARNING:
+   callers on SMP boxen should always check for CPU migration on
+   return of this routine. One can control the kind of interrupts
+   which are going to be sync'ed using the syncmask
+   parameter. IPIPE_IRQMASK_ANY plays them all, IPIPE_IRQMASK_VIRT
+   plays virtual interrupts only. */
+
+void __adeos_sync_stage (unsigned long syncmask)
+
+{
+    unsigned long mask, submask, flags;
+    struct adcpudata *cpudata;
+    adeos_declare_cpuid;
+    int level, rank;
+    adomain_t *adp;
+    unsigned irq;
+
+    adeos_lock_cpu(flags);
+
+    adp = adp_cpu_current[cpuid];
+    cpudata = &adp->cpudata[cpuid];
+
+    do
+	{
+	if (unlikely(test_and_set_bit(IPIPE_SYNC_FLAG,&cpudata->status)))
+	    goto release_cpu_and_exit;
+
+	/* The policy here is to keep the dispatching code
+	   interrupt-free by stalling the current stage. If the upper
+	   domain handler (which we call) wants to re-enable
+	   interrupts while in a safe portion of the code
+	   (e.g. SA_INTERRUPT flag unset for Linux's sigaction()), it
+	   will have to unstall (then stall again before returning to
+	   us!) the stage when it sees fit. */
+
+	while ((mask = cpudata->irq_pending_hi) != 0)
+	    {
+	    /* Give a slight priority advantage to high-numbered IRQs
+	       like the virtual ones. */
+	    level = ffnz(mask);
+	    clear_bit(level,&cpudata->irq_pending_hi);
+
+	    while ((submask = cpudata->irq_pending_lo[level]) != 0)
+		{
+		rank = ffnz(submask);
+		irq = (level << IPIPE_IRQ_ISHIFT) + rank;
+
+		if (unlikely(test_bit(IPIPE_LOCK_FLAG,&adp->irqs[irq].control)))
+		    {
+		    clear_bit(rank,&cpudata->irq_pending_lo[level]);
+		    continue;
+		    }
+
+		if (likely(--cpudata->irq_hits[irq] == 0))
+		    clear_bit(rank,&cpudata->irq_pending_lo[level]);
+
+		/* Allow the sync routine to be reentered on behalf of
+		   the IRQ handler and any execution context switched
+		   in by the IRQ handler. The latter also means that
+		   returning from the switched out context is always
+		   safe even if the sync routine has been reentered in
+		   the meantime. */
+
+		set_bit(IPIPE_STALL_FLAG,&cpudata->status);
+
+		clear_bit(IPIPE_SYNC_FLAG,&cpudata->status);
+
+		adeos_unlock_cpu(flags);
+
+		adeos_hw_sti();
+
+		/* 1. __adeos_irq_regs is only overwritten when a
+		   timer IRQ is caught.
+		   2. IPIPE_CALLASM_FLAG is dummy for this arch. */
+
+		((void (*)(unsigned, struct pt_regs *))adp->irqs[irq].handler)(irq,&__adeos_irq_regs);
+
+		adeos_lock_cpu(flags);
+
+		clear_bit(IPIPE_STALL_FLAG,&cpudata->status);
+
+		if (test_and_set_bit(IPIPE_SYNC_FLAG,&cpudata->status))
+		    goto release_cpu_and_exit;
+		}
+	    }
+
+	clear_bit(IPIPE_SYNC_FLAG,&cpudata->status);
+	}
+    while (cpudata->irq_pending_hi != 0);
+
+release_cpu_and_exit:
+
+    adeos_unlock_cpu(flags);
+}
+
+static inline void __adeos_walk_pipeline (struct list_head *pos, int cpuid)
+
+{
+    while (pos != &__adeos_pipeline)
+	{
+    	adomain_t *_adp = list_entry(pos,adomain_t,p_link);
+
+	if (test_bit(IPIPE_STALL_FLAG,&_adp->cpudata[cpuid].status))
+	    break; /* Stalled stage -- do not go further. */
+
+	if (_adp->cpudata[cpuid].irq_pending_hi != 0)
+	    {
+	    if (_adp == adp_cpu_current[cpuid])
+		__adeos_sync_stage(IPIPE_IRQMASK_ANY);
+	    else
+		{
+		__adeos_switch_to(_adp,cpuid);
+
+		if (!test_bit(IPIPE_STALL_FLAG,&adp_cpu_current[cpuid]->cpudata[cpuid].status) &&
+		    adp_cpu_current[cpuid]->cpudata[cpuid].irq_pending_hi != 0)
+		    __adeos_sync_stage(IPIPE_IRQMASK_ANY);
+		}
+
+	    break;
+	    }
+	else if (_adp == adp_cpu_current[cpuid])
+	    break;
+
+	pos = _adp->p_link.next;
+	}
+}
+
+/* __adeos_handle_irq() -- ADEOS' generic IRQ handler. An optimistic
+   interrupt protection log is maintained here for each domain. 
+   Interrupts are off on entry. */
+
+
+int __adeos_handle_irq_intercept (struct pt_regs *regs)
+
+{
+    int irq;
+
+
+    if (!adp_pipelined)
+	{
+	return do_IRQ(regs);
+	}
+
+    if ((irq = ppc_md.get_irq(regs)) < 0) 
+        {
+	printk(KERN_ERR "ADEOS: spurious interrupt %d\n", irq);
+	return 1;
+        }
+#ifdef ADOES_EARLY_ACK
+    ack_irq(irq);
+#endif
+
+    return __adeos_handle_irq(irq, regs);
+}
+
+int __adeos_handle_timer_intercept (struct pt_regs *regs)
+
+{
+    if (!adp_pipelined)
+        {
+	return timer_interrupt(regs);
+	}
+
+    return __adeos_handle_irq(__adeos_timer_virq, regs);
+}
+
+/* ADEOS's version of irq.c:do_IRQ(). */
+
+int adeos_do_IRQ(int irq, struct pt_regs *regs)
+{
+    int cpu = smp_processor_id();
+    hardirq_enter( cpu );
+    ppc_irq_dispatch_handler(regs, irq);
+    hardirq_exit( cpu );
+
+    if (softirq_pending(cpu))
+	do_softirq();
+    return 1; /* lets ret_from_int know we can do checks */
+}
+
+/* ADEOS's version of irq.c:timer_interrupt(). */
+
+int adeos_timer_interrupt(int irq, struct pt_regs *regs)
+{
+    __adeos_irq_regs.msr = regs->msr; /* for do_timer() */
+    return timer_interrupt(regs);
+}
+
+int __adeos_handle_irq (int irq, struct pt_regs *regs)
+
+{
+    struct list_head *head, *pos;
+    adeos_declare_cpuid;
+    int m_ack, s_ack;
+
+    m_ack = irq & ADEOS_IRQ_ACKED;
+    irq &= ADEOS_IRQ_ACKED_MASK;
+
+    if (irq >= IPIPE_NR_IRQS)
+	{
+	printk(KERN_ERR "ADEOS: spurious interrupt %d\n",irq);
+	return 1;
+	}
+
+    adeos_load_cpuid();
+
+    s_ack = m_ack;
+
+    if (unlikely(test_bit(IPIPE_STICKY_FLAG,&adp_cpu_current[cpuid]->irqs[irq].control)))
+	head = &adp_cpu_current[cpuid]->p_link;
+    else
+	head = __adeos_pipeline.next;
+
+    /* Ack the interrupt. */
+
+    pos = head;
+
+    while (pos != &__adeos_pipeline)
+	{
+    	adomain_t *_adp = list_entry(pos,adomain_t,p_link);
+
+	/* For each domain handling the incoming IRQ, mark it as
+           pending in its log. */
+
+	if (test_bit(IPIPE_HANDLE_FLAG,&_adp->irqs[irq].control))
+	    {
+	    /* Domains that handle this IRQ are polled for
+	       acknowledging it by decreasing priority order. The
+	       interrupt must be made pending _first_ in the domain's
+	       status flags before the PIC is unlocked. */
+
+	    _adp->cpudata[cpuid].irq_hits[irq]++;
+	    __adeos_set_irq_bit(_adp,cpuid,irq);
+
+	    /* Always get the first master acknowledge available. Once
+	       we've got it, allow slave acknowledge handlers to run
+	       (until one of them stops us). */
+
+	    if (_adp->irqs[irq].acknowledge != NULL)
+		{
+		if (!m_ack)
+		    m_ack = _adp->irqs[irq].acknowledge(irq);
+		else if (test_bit(IPIPE_SHARED_FLAG,&_adp->irqs[irq].control) && !s_ack)
+		    s_ack = _adp->irqs[irq].acknowledge(irq);
+		}
+	    }
+
+	/* If the domain does not want the IRQ to be passed down the
+	   interrupt pipe, exit the loop now. */
+
+	if (!test_bit(IPIPE_PASS_FLAG,&_adp->irqs[irq].control))
+	    break;
+
+	pos = _adp->p_link.next;
+	}
+
+    /* Now walk the pipeline, yielding control to the highest priority
+       domain that has pending interrupt(s) or immediately to the
+       current domain if the interrupt has been marked as
+       'sticky'. This search does not go beyond the current domain in
+       the pipeline. To understand this code properly, one must keep
+       in mind that domains having a higher priority than the current
+       one are sleeping on the adeos_suspend_domain() service. In
+       addition, domains having a lower priority have been preempted
+       by an interrupt dispatched to a more prioritary domain. Once
+       the first and most prioritary stage has been selected here, the
+       subsequent stages will be activated in turn when each visited
+       domain calls adeos_suspend_domain() to wake up its neighbour
+       down the pipeline. */
+
+    __adeos_walk_pipeline(head,cpuid);
+
+    return (adp_cpu_current[cpuid] == adp_root &&
+	    !test_bit(IPIPE_STALL_FLAG,&adp_root->cpudata[cpuid].status));
+}
+
+
+/* adeos_trigger_irq() -- Push the interrupt to the pipeline entry
+   just like if it has been actually received from a hw source. This
+   both works for real and virtual interrupts. This also means that
+   the current domain might be immediately preempted by a more
+   prioritary domain who happens to handle this interrupt. */
+
+int adeos_trigger_irq (unsigned irq)
+
+{
+    struct pt_regs regs;
+
+    if (irq >= IPIPE_NR_IRQS ||
+	(adeos_virtual_irq_p(irq) && !test_bit(irq - IPIPE_VIRQ_BASE,&__adeos_virtual_irq_map)))
+	return -EINVAL;
+
+    adeos_hw_local_irq_flags(regs.msr);
+
+    __adeos_handle_irq(irq | ADEOS_IRQ_ACKED, &regs);
+
+    return 1;
+}
+
+int __adeos_enter_syscall (struct pt_regs *regs)
+
+{
+    if (unlikely(__adeos_event_monitors[ADEOS_SYSCALL_PROLOGUE] > 0))
+	return __adeos_handle_event(ADEOS_SYSCALL_PROLOGUE,regs);
+    return 0;
+}
+
+int __adeos_exit_syscall (void) 
+
+{
+    if (unlikely(__adeos_event_monitors[ADEOS_SYSCALL_EPILOGUE] > 0))
+	return __adeos_handle_event(ADEOS_SYSCALL_EPILOGUE,NULL);
+    return 0;
+}
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/entry.S.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/entry.S
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/entry.S.ADEOS	Thu Oct 30 01:32:14 2003
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/entry.S	Tue Jun 15 11:31:39 2004
@@ -53,6 +53,18 @@
 	lis	r10,0x1000
 	andc	r11,r11,r10
 	stw	r11,_CCR(r1)
+#ifdef CONFIG_ADEOS_CORE
+	addi	r3,r1,GPR0
+	bl	__adeos_enter_syscall /* FIXME fast exit */
+	lwz	r0,GPR0(r1)	/* Restore registers for syscall */
+	lwz	r3,GPR3(r1)	/* FIXME do we need that much? */
+	lwz	r4,GPR4(r1)
+	lwz	r5,GPR5(r1)
+	lwz	r6,GPR6(r1)
+	lwz	r7,GPR7(r1)
+	lwz	r8,GPR8(r1)
+	lwz	r9,GPR9(r1)
+#endif /* CONFIG_ADEOS_CORE */
 #ifdef SHOW_SYSCALLS
 #ifdef SHOW_SYSCALLS_TASK
 	lis	r31,show_syscalls_task@ha
@@ -105,6 +117,10 @@
 	.globl	ret_from_syscall_1
 ret_from_syscall_1:
 20:	stw	r3,RESULT(r1)	/* Save result */
+#ifdef CONFIG_ADEOS_CORE
+	bl	__adeos_exit_syscall
+	lwz	r3,RESULT(r1)
+#endif /* CONFIG_ADEOS_CORE */
 #ifdef SHOW_SYSCALLS
 #ifdef SHOW_SYSCALLS_TASK
 	cmp	0,r2,r31
@@ -262,6 +278,106 @@
 	addi	r1,r1,INT_FRAME_SIZE
 	blr
 
+#ifdef CONFIG_ADEOS_CORE
+/*
+ * Domain switch code for PowerPC processors (lifted from RTAI 24.1.12).
+ * r3 = next domain, r4 = adp_cpu_current.
+ */
+_GLOBAL(__adeos_switch_domain)
+	stw	r31, -1*4(r1)
+	stw	r30, -2*4(r1)
+	stw	r29, -3*4(r1)
+	stw	r28, -4*4(r1)
+	stw	r27, -5*4(r1)
+	stw	r26, -6*4(r1)
+	stw	r25, -7*4(r1)
+	stw	r24, -8*4(r1)
+	stw	r23, -9*4(r1)
+	stw	r22,-10*4(r1)
+	stw	r21,-11*4(r1)
+	stw	r20,-12*4(r1)
+	stw	r19,-13*4(r1)
+	stw	r18,-14*4(r1)
+	stw	r17,-15*4(r1)
+	stw	r16,-16*4(r1)
+	stw	r15,-17*4(r1)
+	stw	r14,-18*4(r1)
+	stw	r13,-19*4(r1)
+	stw	r12,-20*4(r1)
+	stw	r11,-21*4(r1)
+	stw	r10,-22*4(r1)
+	stw	 r9,-23*4(r1)
+	stw	 r8,-24*4(r1)
+	stw	 r7,-25*4(r1)
+	stw	 r6,-26*4(r1)
+	stw	 r5,-27*4(r1)
+	stw	 r4,-28*4(r1)
+	stw	 r3,-29*4(r1)
+	stw	 r2,-30*4(r1)
+	stw	 r0,-31*4(r1)
+	mfctr	 r5
+	stw	 r5,-32*4(r1)
+	mfcr	 r5
+	stw	 r5,-33*4(r1)
+	mfxer	 r5
+	stw	 r5,-34*4(r1)
+	mflr	 r5
+	stw	 r5,-35*4(r1)
+	mfmsr	 r5
+	stw	 r5,-36*4(r1)
+
+	lwz	 r5,0(r4)
+	stw	 r1,4(r5)
+
+	stw	 r3,0(r4)
+
+	lwz	 r1,4(r3)
+
+	lwz 	 r2,-36*4(r1)
+	mtmsr	 r2
+	lwz	 r2,-35*4(r1)
+	mtlr	 r2
+	lwz	 r2,-34*4(r1)
+	mtxer	 r2
+	lwz	 r2,-33*4(r1)
+	mtcr	 r2
+	lwz	 r2,-32*4(r1)
+	mtctr	 r2
+	lwz	 r0,-31*4(r1)
+	lwz	 r2,-30*4(r1)
+	lwz	 r3,-29*4(r1)
+	lwz	 r4,-28*4(r1)
+	lwz	 r5,-27*4(r1)
+	lwz	 r6,-26*4(r1)
+	lwz	 r7,-25*4(r1)
+	lwz	 r8,-24*4(r1)
+	lwz	 r9,-23*4(r1)
+	lwz	r10,-22*4(r1)
+	lwz	r11,-21*4(r1)
+	lwz	r12,-20*4(r1)
+	lwz	r13,-19*4(r1)
+	lwz	r14,-18*4(r1)
+	lwz	r15,-17*4(r1)
+	lwz	r16,-16*4(r1)
+	lwz	r17,-15*4(r1)
+	lwz	r18,-14*4(r1)
+	lwz	r19,-13*4(r1)
+	lwz	r20,-12*4(r1)
+	lwz	r21,-11*4(r1)
+	lwz	r22,-10*4(r1)
+	lwz	r23, -9*4(r1)
+	lwz	r24, -8*4(r1)
+	lwz	r25, -7*4(r1)
+	lwz	r26, -6*4(r1)
+	lwz	r27, -5*4(r1)
+	lwz	r28, -4*4(r1)
+	lwz	r29, -3*4(r1)
+	lwz	r30, -2*4(r1)
+	lwz	r31, -1*4(r1)
+
+	blr
+#endif /* CONFIG_ADEOS_CORE */
+
 	.globl	syscall_direct_return
 syscall_direct_return:
 	addi	r1,r3,-STACK_FRAME_OVERHEAD
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_44x.S.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_44x.S
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_44x.S.ADEOS	Thu Oct 30 01:32:14 2003
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_44x.S	Tue Jun 15 11:07:08 2004
@@ -535,7 +535,11 @@
 	li      r4,0
 	bl      transfer_to_handler
 _GLOBAL(do_IRQ_intercept)
-	.long   do_IRQ
+#ifdef CONFIG_ADEOS_CORE
+	.long	__adeos_handle_irq_intercept
+#else /* !CONFIG_ADEOS_CORE */
+	.long	do_IRQ
+#endif /* CONFIG_ADEOS_CORE */
 	.long   ret_from_intercept
 	.long	0x500
 
@@ -586,7 +590,11 @@
 	li      r20,MSR_KERNEL
 	bl      transfer_to_handler
 _GLOBAL(timer_interrupt_intercept)
+#ifdef CONFIG_ADEOS_CORE
+	.long	__adeos_handle_timer_intercept;
+#else /* !CONFIG_ADEOS_CORE */
 	.long   timer_interrupt
+#endif /* CONFIG_ADEOS_CORE */
 	.long   ret_from_intercept
 	.long	0x1000
 
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_4xx.S.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_4xx.S
--- linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_4xx.S.ADEOS	Thu Oct 30 01:32:14 2003
+++ linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_4xx.S	Mon Jun  7 22:49:48 2004
@@ -384,7 +384,11 @@
 	li	r4,0
 	bl	transfer_to_handler
 _GLOBAL(do_IRQ_intercept)
+#ifdef CONFIG_ADEOS_CORE
+	.long	__adeos_handle_irq_intercept
+#else /* !CONFIG_ADEOS_CORE */
 	.long	do_IRQ
+#endif /* CONFIG_ADEOS_CORE */
 	.long	ret_from_intercept
 
 /* 0x0600 - Alignment Exception
@@ -456,7 +460,11 @@
 	li	r20,MSR_KERNEL
 	bl	transfer_to_handler
 _GLOBAL(timer_interrupt_intercept)
+#ifdef CONFIG_ADEOS_CORE
+	.long	__adeos_handle_timer_intercept;
+#else /* !CONFIG_ADEOS_CORE */
 	.long	timer_interrupt
+#endif /* CONFIG_ADEOS_CORE */
 	.long	ret_from_intercept
 
 #if 0
+ diff -u linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_8xx.S.ADEOS linuxppc_2_4_devel-D2004-05-07/arch/ppc/kernel/head_8xx.S
